export default {
  state: {
    sheet: null
  },

  mutations: {
    'SET_KIT_SHEET' (state, id) {
      state.sheet = id
    }
  },

  actions: {
    'INIT_KIT' ({ state, commit, dispatch, getters }) {
      const ids = dispatch('GET_ALL_NODES_IDS', { variant: 'kit', dataLevel: 'partial' })
      return dispatch('GET_NODES', { ids, dataLevel: 'partial' })
    },

    async 'OPEN_KIT_NODE' ({ state, commit, dispatch }, id) {
      commit('SET_KIT_SHEET', id)
      commit('ADD_HISTORY_ENTRIES', [id])
      return dispatch('GET_NODE', { id, dataLevel: 'full' })
    },

    'CLOSE_KIT_NODE' ({ state, commit }) {
      commit('SET_KIT_SHEET', null)
    }
  },

  getters: {
    sheets: (state, getters, rootState) => {
      const ids = rootState.ids.kit
      if (ids === undefined) return
      const nodes = ids.map(id => rootState.nodes[id])
      if (nodes.some(node => node === undefined)) return
      return nodes
    },

    sheet: (state, getters, rootState) => {
      if (state.sheet === undefined || state.sheet === null) return state.sheet
      return rootState.nodes[state.sheet]
    }
  }
}
